# frozen_string_literal: true

# Licensed to the Software Freedom Conservancy (SFC) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The SFC licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

# This file is automatically generated. Any changes will be lost!
module Selenium
  module DevTools
    module V85
      class DeviceOrientation

        def initialize(devtools)
          @devtools = devtools
        end

        def on(event, &block)
          event = EVENTS[event] if event.is_a?(Symbol)
          @devtools.callbacks["DeviceOrientation.#{event}"] << block
        end

        def clear_device_orientation_override
          @devtools.send_cmd('DeviceOrientation.clearDeviceOrientationOverride')
        end

        def set_device_orientation_override(alpha:, beta:, gamma:)
          @devtools.send_cmd('DeviceOrientation.setDeviceOrientationOverride',
                             alpha: alpha,
                             beta: beta,
                             gamma: gamma)
        end

      end # DeviceOrientation
    end # V85
  end # DevTools
end # Selenium