# frozen_string_literal: true

# Licensed to the Software Freedom Conservancy (SFC) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The SFC licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

# This file is automatically generated. Any changes will be lost!
module Selenium
  module DevTools
    module V92
      class Cast
        EVENTS = {
          sinks_updated: 'sinksUpdated',
          issue_updated: 'issueUpdated',
        }.freeze

        def initialize(devtools)
          @devtools = devtools
        end

        def on(event, &block)
          event = EVENTS[event] if event.is_a?(Symbol)
          @devtools.callbacks["Cast.#{event}"] << block
        end

        def enable(presentation_url: nil)
          @devtools.send_cmd('Cast.enable',
                             presentationUrl: presentation_url)
        end

        def disable
          @devtools.send_cmd('Cast.disable')
        end

        def set_sink_to_use(sink_name:)
          @devtools.send_cmd('Cast.setSinkToUse',
                             sinkName: sink_name)
        end

        def start_tab_mirroring(sink_name:)
          @devtools.send_cmd('Cast.startTabMirroring',
                             sinkName: sink_name)
        end

        def stop_casting(sink_name:)
          @devtools.send_cmd('Cast.stopCasting',
                             sinkName: sink_name)
        end

      end # Cast
    end # V92
  end # DevTools
end # Selenium