# frozen_string_literal: true

# Licensed to the Software Freedom Conservancy (SFC) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The SFC licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

# This file is automatically generated. Any changes will be lost!
module Selenium
  module DevTools
    module V92
      class WebAudio
        EVENTS = {
          context_created: 'contextCreated',
          context_will_be_destroyed: 'contextWillBeDestroyed',
          context_changed: 'contextChanged',
          audio_listener_created: 'audioListenerCreated',
          audio_listener_will_be_destroyed: 'audioListenerWillBeDestroyed',
          audio_node_created: 'audioNodeCreated',
          audio_node_will_be_destroyed: 'audioNodeWillBeDestroyed',
          audio_param_created: 'audioParamCreated',
          audio_param_will_be_destroyed: 'audioParamWillBeDestroyed',
          nodes_connected: 'nodesConnected',
          nodes_disconnected: 'nodesDisconnected',
          node_param_connected: 'nodeParamConnected',
          node_param_disconnected: 'nodeParamDisconnected',
        }.freeze

        def initialize(devtools)
          @devtools = devtools
        end

        def on(event, &block)
          event = EVENTS[event] if event.is_a?(Symbol)
          @devtools.callbacks["WebAudio.#{event}"] << block
        end

        def enable
          @devtools.send_cmd('WebAudio.enable')
        end

        def disable
          @devtools.send_cmd('WebAudio.disable')
        end

        def get_realtime_data(context_id:)
          @devtools.send_cmd('WebAudio.getRealtimeData',
                             contextId: context_id)
        end

      end # WebAudio
    end # V92
  end # DevTools
end # Selenium