# frozen_string_literal: true

# Licensed to the Software Freedom Conservancy (SFC) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The SFC licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

# This file is automatically generated. Any changes will be lost!
module Selenium
  module DevTools
    module V93
      class DOMSnapshot

        def initialize(devtools)
          @devtools = devtools
        end

        def on(event, &block)
          event = EVENTS[event] if event.is_a?(Symbol)
          @devtools.callbacks["DOMSnapshot.#{event}"] << block
        end

        def disable
          @devtools.send_cmd('DOMSnapshot.disable')
        end

        def enable
          @devtools.send_cmd('DOMSnapshot.enable')
        end

        def get_snapshot(computed_style_whitelist:, include_event_listeners: nil, include_paint_order: nil, include_user_agent_shadow_tree: nil)
          @devtools.send_cmd('DOMSnapshot.getSnapshot',
                             computedStyleWhitelist: computed_style_whitelist,
                             includeEventListeners: include_event_listeners,
                             includePaintOrder: include_paint_order,
                             includeUserAgentShadowTree: include_user_agent_shadow_tree)
        end

        def capture_snapshot(computed_styles:, include_paint_order: nil, include_dom_rects: nil, include_blended_background_colors: nil, include_text_color_opacities: nil)
          @devtools.send_cmd('DOMSnapshot.captureSnapshot',
                             computedStyles: computed_styles,
                             includePaintOrder: include_paint_order,
                             includeDOMRects: include_dom_rects,
                             includeBlendedBackgroundColors: include_blended_background_colors,
                             includeTextColorOpacities: include_text_color_opacities)
        end

      end # DOMSnapshot
    end # V93
  end # DevTools
end # Selenium